#!/bin/bash
#
# AppCrack 0.8
# Made by MadHouse
#
# Based on xCrack and DCrypt
# Optimized for 3.0
#
# Thanks to: puy0, SaladFork, Flox, Flawless, and FloydianSlip, TraderTic, and tripleked!
#

NORMAL="\033[0m"
RED="\033[31m"
YELLOW="\033[33m"
GREEN="\033[32m"
clear

echo
echo "   --------------------------------------"
echo "   AppCrack Tool for Cracking iPhone Apps"
echo "   Made by MadHouse"
echo "   --------------------------------------"
echo

if [ ! -e /usr/bin/plutil ]; then
	echo "ERROR: Cannot find plutil (Install Erica Utilities)"
	echo "Will now install Erica Utilities. Please quit if you don't wish to..."
	apt-get install com.ericasadun.utilities
fi

if [ ! -e /usr/bin/sqlite3 ]; then
	echo "ERROR: Cannot find sqlite3 (Install SQLite v3)"
	echo "Will now install SQLite v3. Please quit if you don't wish to..."
	apt-get install sqlite3
	apt-get install sqlite3-lib
fi

if [ ! -e /usr/bin/awk ]; then
	echo "ERROR: Cannot find awk (Install gawk)"
	echo "Will now install gawk. Please quit if you don't wish to..."
	apt-get install gawk
fi

if [ ! -e /usr/sbin/chown ]; then
	echo "ERROR: Cannot find coreutils (Install Core Utilities)"
	echo "Will now install Core Utilities. Please quit if you don't wish to..."
	apt-get install coreutils
fi

if [ ! -e /usr/bin/zip ]; then
	echo "ERROR: Cannot find zip (Install zip)"
	echo "Will now install zip. Please quit if you don't wish to..."
	apt-get install zip
fi

if [ ! -e /usr/bin/gdb ]; then
	echo "ERROR: Cannot find gdb (Install GNU Debugger (gdb))"
	echo "Will now install gdb. Please quit if you don't wish to..."
	apt-get install gdb
fi

if [ ! -e /usr/bin/otool ]; then
	echo "ERROR: Cannot find otool (Install Darwin CC Tools)"
	echo "Will now install Darwin CC Tools. Please quit if you don't wish to..."
	apt-get install odcctools
	exit 1
fi

if [ $# -ne 2 ]; then
	echo "To Use, Type: ./$(basename $0) [App Name] [Cracker Name]"
	echo
	exit 1
fi

AppInput=$1
CrackerName=$2

if [ -d "$AppInput" ]; then
        tempLoc=$AppInput
else
	echo "Searching for $AppInput"
	tempLoc=$(find /var/mobile/Applications -iname "$AppInput.app")
	if [ -z "$tempLoc" ]; then
	echo "FAILED"	
	echo 
	echo "Cannot Find $AppInput"
	echo 
		exit 1
	fi
	AppCount=$(find /var/mobile/Applications -iname "$AppInput.app" | wc -l)
	if [ $AppCount -gt 1 ]; then
	echo "FAILED"	
	echo 
	echo "Found Multiple Install Locations:"
		find /var/mobile/Applications -iname "$AppInput.app"
		echo 
		exit 1
	fi
fi

AppPath=$(dirname "$tempLoc")
AppName=$(basename "$tempLoc")
AppExec=$(plutil -key CFBundleExecutable "$tempLoc/Info.plist" 2>&1)
AppVer=$(plutil -key CFBundleVersion "$tempLoc/Info.plist" 2>&1)
AppDisplayName=$(plutil -key CFBundleDisplayName "$tempLoc/Info.plist" 2>&1)

if [ ! -d "$AppPath" ]; then
	echo "FAILED"
	echo 
	echo "Unable to Find Install Location"
	echo 
	exit 1
fi

if [ ! -d "$AppPath/$AppName" ]; then
	echo "FAILED"
	echo
	echo "Unable to Find App Location"
	echo 	
	exit 1
fi

if [ ! -e "$AppPath/$AppName/$AppExec" ]; then
	echo "FAILED"
	echo
	echo "Unable to Find Executable"
	echo 
	exit 1
fi

echo "DONE"

echo 
echo "Creating Workspace"
WorkDir="/tmp/DecryptApp-$(date +%Y%m%d-%H%M%S)"
NewAppDir="$HOME/Cracked"

if [ -e "$WorkDir" ]; then
	rm -rf "$WorkDir"
fi

mkdir -p "$WorkDir"

if [ ! -e "$NewAppDir" ]; then
	mkdir -p "$NewAppDir"
fi

if [ ! -d "$WorkDir" -o ! -d "$NewAppDir" ]; then
	echo "FAILED"
	echo
	echo "Unable to Create Workspace"
	echo
	exit 1
fi

echo "DONE"
echo 
echo "Setting up Application"

cp -a "$AppPath/$AppName/" "$WorkDir/"

if [ ! -e "$WorkDir/$AppName/$AppExec" ]; then
	echo "FAILED"
	echo
	echo "Unable to Set up Application"
	rm -fr "$WorkDir"
	echo 
	exit 1
fi

echo "DONE"
echo 
echo "Analyzing Application"


CryptSize=$(otool -l "$WorkDir/$AppName/$AppExec" | grep cryptsize | awk '{print $2}')
if [ ! $CryptSize ]; then
	echo "FAILED"
	echo
	echo "Unable to Find CryptSize"
	rm -fr "$WorkDir"
	echo 
	exit 1
fi

CryptOff=$(otool -l "$WorkDir/$AppName/$AppExec" | grep cryptoff | awk '{print $2}')
if [ ! $CryptOff ]; then
        echo "FAILED"
	echo
	echo "Unable to Find CryptOff"
        rm -fr "$WorkDir"
	echo 
	exit 1
fi

CryptID=$(otool -l "$WorkDir/$AppName/$AppExec" | grep cryptid | awk '{print $2}')
if [ $CryptID -ne "1" ]; then
	echo "FAILED"
	echo 
	echo "Application is Already Cracked or in Beta"
	echo 
	rm -fr "$WorkDir"
	exit 1
fi

echo "DONE"
echo 
echo "Editing CryptID"

# "/System/Library/Frameworks" in hex
PathAsHex="2f53797374656d2f4c6962726172792f4672616d65776f726b73"

# - Convert to hex on 1 long line, only take stuff before the path string,
# - Convert to 1 byte set per line, find 0x01 (line number is offset in the real file),
# - Strip newlines, reverse the order
oneLocations=($(od -A n -t x1 -v "$WorkDir/$AppName/$AppExec" | \
	tr -d ' ','\n' | \
	sed "s/$PathAsHex.*\$//" | \
	sed "s/../&\n/g" | \
	grep -n -s 01 | \
	cut -d : -f 1 | \
	sort -nr | \
	tr "\n" " "))

for TryOffset in "${oneLocations[@]}"; do
	cp -a "$WorkDir/$AppName/$AppExec" "$WorkDir/$AppName/$AppExec.trying"
	foo=$(echo -ne "\x00" | dd bs=1 seek=$((TryOffset - 1)) conv=notrunc status=noxfer of="$WorkDir/$AppName/$AppExec.trying" 2>&1> /dev/null)
	cid=$(otool -l "$WorkDir/$AppName/$AppExec.trying" | grep cryptid | awk '{print $2}')
	if [ $cid -eq 0 ]; then
		break
	fi
	rm "$WorkDir/$AppName/$AppExec.trying"
done

if [ ! -e "$WorkDir/$AppName/$AppExec.trying" ]; then
	echo "FAILED"
	echo 
	echo "Unable to find CryptID"
	rm -fr "$WorkDir"
	echo 
	exit 1
fi

mv "$WorkDir/$AppName/$AppExec.trying" "$WorkDir/$AppName/$AppExec"

echo "DONE"
echo  
echo "Dumping Unencrypted Data"

echo -e "set sharedlibrary load-rules \".*\" \".*\" none\r\n\
set inferior-auto-start-dyld off\r\n\
set sharedlibrary preload-libraries off\r\n\
set sharedlibrary load-dyld-symbols off\r\n\
handle all nostop\r\n\
break *0x2000\r\n
commands 1\r\n\
dump memory $WorkDir/dump.bin 0x2000 $(($CryptSize + 0x2000))\r\n\
kill\r\n\
quit\r\n\
end\r\n\
start" > $WorkDir/batch.gdb

foo=$(gdb -q -e "$AppPath/$AppName/$AppExec" -x $WorkDir/batch.gdb -batch 2>&1> /dev/null)

rm $WorkDir/batch.gdb

echo "DONE"
echo 
echo "Verifiying Dump"

DumpSize=$(stat -c%s "$WorkDir/dump.bin")
if [ "$DumpSize" != "$CryptSize" ]; then
	echo "FAILED"
	echo 
	echo "Memory Dump is Corrupt or Doesn't Exist"
	rm -fr "$WorkDir"
	echo 
	exit 1
fi

echo "DONE"
echo  
echo "Replacing Encrypted Data"
foo=$(dd seek=4096 bs=1 conv=notrunc if="$WorkDir/dump.bin" of="$WorkDir/$AppName/$AppExec" 2>&1> /dev/null)
rm "$WorkDir/dump.bin"

echo "DONE"
echo 
echo "Signing Application"
foo=$(ldid -s "$WorkDir/$AppName/$AppExec" 2>&1> /dev/null)
plutil -set 'SignerIdentity' -value 'Apple iPhone OS Application Signing' "$WorkDir/$AppName/Info.plist" 2>&1> /dev/null

if [ -e "$WorkDir/$AppName/SC_Info" ]; then
	echo "DONE"
	echo 
	echo "Removing Private Information"
	rm -fr "$WorkDir/$AppName/SC_Info"
fi

if [ -e "$WorkDir/$AppName/_CodeSignature" ]; then
	rm -fr "$WorkDir/$AppName/_CodeSignature"
fi

if [ -h "$WorkDir/$AppName/CodeResources" ]; then
	rm -fr "$WorkDir/$AppName/CodeResources"
fi

if [ -e "$WorkDir/$AppName/ResourceRules.plist" ]; then
	rm -fr "$WorkDir/$AppName/ResourceRules.plist"
fi

echo "DONE"
echo 
echo "Packaging IPA"

mkdir -p "$WorkDir/Payload"
if [ ! -e "$WorkDir/Payload" ]; then
	echo "FAILED"
	echo
	echo "Cannot Create Payload Folder"
	rm -fr "$WorkDir"
	echo 
	exit 1
fi
mv "$WorkDir/$AppName" "$WorkDir/Payload/"

echo "DONE"
echo 
echo "Getting iTunesArtwork"

if [ -e "$AppPath/iTunesArtwork" ]; then
	cp -a "$AppPath/iTunesArtwork" "$WorkDir/"
else
	echo "FAILED"
	echo 
	echo "Cannot Get iTunesArtwork"
fi

echo "DONE"
echo 
echo "Compressing IPA"
IPAName=$NewAppDir/$(echo $AppDisplayName | sed -e "s: :_:g")-v$AppVer-$CrackerName.ipa
cd "$WorkDir"
zip -m -r "$IPAName" * 2>&1> /dev/null
cd - 2>&1> /dev/null
if [ ! -e "$IPAName" ]; then
	echo "FAILED"
	echo 
	echo "Cannot Compress IPA"
	rm -fr "$WorkDir"
	echo 
	exit 1
fi

echo "DONE"
echo 
echo "Cleaning Up"
rm -rf "$WorkDir"

echo "DONE"
echo  
echo "Process Complete!"
echo "Cracked IPA Available at $IPAName"
echo " "

